package cn.estsh.i3plus.ext.mes.apiservice.controller.busi.bu3;

import cn.estsh.i3plus.ext.mes.api.busi.bu3.ISxCategoryCompleteRateService;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxCategoryCompleteRateModel;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxCompleteRateChartModel;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.impp.framework.base.controller.MesBaseController;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(CommonConstWords.BASE_URL_MES)
@Api(tags = "日完结率/达成率报表控制层")
public class SxCategoryCompleteRateController extends MesBaseController {

    @Autowired
    private ISxCategoryCompleteRateService categoryCompleteRateService;

    @PostMapping(value = "/sx/ext/category-complete-rate/query")
    @ApiOperation(value = "日完结率/达成率报表")
    public ResultBean queryCategoryCompleteRate(@RequestBody SxCategoryCompleteRateModel data) {
        try {
            ValidatorBean.beginValid(data)
                    .notNull(MesExtConstWords.DIMENSION, data.getDimension())
                    .notNull(MesExtConstWords.WORK_TIME_START, data.getWorkTimeStart())
                    .notNull(MesExtConstWords.WORK_TIME_END, data.getWorkTimeEnd());
            data.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultObject(categoryCompleteRateService.queryCategoryCompleteRate(data));
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @PostMapping(value = "/sx/ext/complete-rate-chart/query")
    @ApiOperation(value = "完结率/达成率报表")
    public ResultBean queryCompleteRateChart(@RequestBody SxCompleteRateChartModel data) {
        try {
            ValidatorBean.beginValid(data)
                    .notNull(MesExtConstWords.DIMENSION, data.getDimension())
                    .notNull(MesExtConstWords.DIMENSION_1, data.getDimension1())
                    .notNull(MesExtConstWords.WORK_TIME_START, data.getWorkTimeStart())
                    .notNull(MesExtConstWords.WORK_TIME_END, data.getWorkTimeEnd())
                    .notNull(MesExtConstWords.FLAG, data.getFlag());
            data.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultObject(categoryCompleteRateService.queryCompleteRateChart(data));
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
